(= html_preamble() =)
<html>
<head>
<title>eDAQ Armada</title>
<link type="text/css" href="css/jquery.ui.all.css" rel="stylesheet">
<link type="text/css" href="css/slick.grid.css" rel="stylesheet" media="screen" charset="utf-8">
<link type="text/css" href="css/slick.columnpicker.css" rel="stylesheet" media="screen" charset="utf-8">
<link type="text/css" href="css/jquery.svg.css" rel="stylesheet">
<link type="text/css" href="js/armada_readouts/svg/gauge.css" rel="stylesheet">
<link type="text/css" href="css/armada.css" rel="stylesheet">

<script type="text/javascript" src="js/underscore-min.js"></script>
<script type="text/javascript" src="js/jquery.min.js"></script>
<script type="text/javascript" src="js/jquery-ui.min.js"></script>
<script type="text/javascript" src="js/jquery.json.js"></script>
<script type="text/javascript" src="js/jquery.cookie.js"></script>
<script type="text/javascript" src="js/jquery.url.js"></script>
<script type="text/javascript" src="js/jquery.event.drag-2.0.min.js"></script>
<script type="text/javascript" src="js/jquery.command.js"></script>
<script type="text/javascript" src="js/slick.core.js"></script>
<script type="text/javascript" src="js/slick.editors.js"></script>
<script type="text/javascript" src="js/slick.grid.js"></script>
<script type="text/javascript" src="js/slick.dataview.js"></script>
<script type="text/javascript" src="js/slick.armada_setup_model.js"></script>
<script type="text/javascript" src="js/slick-controls/slick.columnpicker.js"></script>
<script type="text/javascript" src="js/slick-plugins/slick.checkboxselectcolumn.js"></script>
<script type="text/javascript" src="js/jquery.armada_grid.js"></script>

<script type="text/javascript" src="js/jquery.svg.min.js"></script>
<script type="text/javascript" src="js/jquery.svgdom.min.js"></script>
<script type="text/javascript" src="js/jquery.svganim.min.js"></script>
<script type="text/javascript" src="js/armada_readouts/dial.js"></script>
<script type="text/javascript" src="js/armada_readouts/bar.js"></script>
<script type="text/javascript" src="js/armada_readouts/reading.js"></script>
<script type="text/javascript" src="js/armada_readouts/strip_multi.js"></script>

<script type="text/javascript" src="js/uuid.js"></script>
<script type="text/javascript" src="js/jquery.armada_comet.js"></script>
<!-- script type="text/javascript" src="js/jquery.armada_simulator.js"></script -->
<script type="text/javascript" src="js/jquery.armada_slickgrid.js"></script>
<script type="text/javascript">
    var server_session = (= session_json =);
</script>
<script type="text/javascript" src="js/armada_defaults.js"></script>
<script type="text/javascript" src="js/armada.js"></script>

</head>
<body>
<div id="panel" class="fullscreen">

<div id="header">
    <p>eDAQ Armada
        <span class="header-separator">-</span>
        <a href="#edit-menu">Edit</a>
        <span class="header-separator">//</span>
        <span id="header_setup_selector"><input id="test_name_auto" class="invisible-autocomplete">"<span id="header_test_name" class="V-summary_test_name"></span>"</span>
        <span class="header-separator">-</span>
        <span id="comet-control"></span>

        <span class="armada-error-summary">
        <span class="armada-validation-icon armada-error-icon">&nbsp;</span><span class="armada-error-count">0</span>
        <span class="armada-validation-icon armada-warning-icon">&nbsp;</span><span class="armada-warning-count">0</span>
        <span class="armada-validation-icon armada-notice-icon">&nbsp;</span><span class="armada-notice-count">0</span>
        <span class="header-separator">-</span>
        <span>(= session.state.user.name =)</span>
        <span class="header-separator">-</span>
        <a class="sign_out" href="/comet/sign_out?session_key=(= session_key =)">Sign Out</a>
        </span>
    </p>
</div>

<div>
    <div id="tabs-container">
        <div class="search-container">
            <span>Channels: </span>
            <input id="channel-search" type="text">
        </div>
            <div id="available-channels">
                <div><p class="heading">Hardware Channels</p></div>
            </div>
        <div id="tabs">
        </div>
    </div>
</div>

<div id="tabs-repo">
    <div id="summary-tab" class="tab">
        <form class="item-id-ref" data-item_id="summary">
          <table>
            <tr>
              <td>Setup Name:</td>
              <td><input type="text" name="test_name" class="V-summary_test_name"
                         size="80" value=""></td>
            </tr>
            <tr>
              <td>Title:</td>
              <td><input type="text" name="test_title" class="V-summary_test_title"
                         size="80" value=""></td>
            </tr>
            <tr>
              <td>Author:</td>
              <td><input type="text" name="test_author" class="V-summary_test_author"
                         size="80" value=""></td>
            </tr>
            <tr>
              <td valign="top">Synopsis:</td>
              <td><textarea name="test_synopsis" class="V-summary_test_synopsis"
                            cols="80" rows="24"></textarea></td>
            </tr>
          </table>
        </form>
    </div>
    <div id="hardware-tab" class="tab">
        <div id="hardware-list"></div>
    </div>
    <div id="channels-tab" class="tab">
        <div id="spreadsheet_column_selectors" class="armada-radio-set">
            <span>Filter: <input type="text" id="spreadsheet_filter"></span>
            <span>Columns: </span>
        </div>
        <div id="ch_slick"></div>
    </div>
    <div id="displays-tab" class="display-tab">
        <div id="common_gauge_definitions"></div>
    </div>
    <div id="run-tab" class="tab">
        <form>
        <input type="button" name="start_test" value="Start New Test">
        </form>

        <table id="tests" width="100%">
            <tr>
                <th width="40%">Running Tests</th><th width="60%">Details</th>
            </tr>
        </table>
    </div>
    <div id="data-tab" class="tab">
        <table id="files" width="100%">
            <tr>
                <th width="40%">Data Files</th><th width="60%">Details</th>
            </tr>
        </table>
    </div>
    <div id="debug-tab" class="tab">
        <table id="log" width="100%">
            <tr>
                <th>System Log <input type="button" name="refresh_log" value="Refresh"></th>
            </tr>
            <tr><td><div id="log_body"></div></td></tr>
        </table>
    </div>
</div>

</div>

<ul id="context_menu" style="display:none;position:absolute">
<li data="delete_row">Delete Row</li>
</ul>

</body></html>
